#ifndef _OAMPKG_H
#define _OAMPKG_H

#ifdef _SCO_DS

/* Defines for OpenServer */

/* define to include statvfs definitions */
#define _SVID3 1

#include <sys/types.h>
#include <sys/time.h>
#include <stdio.h>
#include <unistd.h>
#include "sys/oamtypes.h"
#include "oamlimits.h"
#include "uwmnttab.h"

#define	DEFPATH		"/bin:/usr/bin"

#define	LABELIT		"/etc/labelit"
#define	MKFS		"/etc/mkfs"
#define CPIOPROC	"/bin/cpio"
#define LSPROC		"/bin/ls"
#define RMCMD		"/bin/rm"
#define MOUNT		"/etc/mount"
#define UMOUNT		"/etc/umount"
#define FSTYP		"/etc/fstyp"
#define DDPROC		"/bin/dd"
#define MAILCMD		"/bin/mail"
#define SHELL		"/bin/sh"
#define CPCMD		"/bin/cp"
#define PKGCHK		"/usr/bin/pkgchk"

#define MOUNT_FOPT	"-f"

#define MKFS_UFS	"%s -f %s %s %s"
#define MKFS_S5		"%s -F %s %s 2370"

#define SYSADM		"/usr/adm/sysadm"
#define LOGDIR		"/var/adm/install/logs"
#define KEYS_FILE       "/usr/spool/pkg/licensekeys"
#define DTAB_PATH       "/etc/default/device.tab"
#define VARTMP		"/usr/tmp"
#define	ETCFS		"/etc/fscmd.d"
#define ETCFSFILE	"mkfs"
#define DEFSPOOLDIR	"/var/spool/pkg"    /* hopsadd */

#define UFS		"HTFS"
#define S5		"S51K"
#define DEFAULT_FS	"S51K"

#else _SCO_DS

/* Defines for UnixWare */

#define DEFPATH		"/sbin:/usr/sbin:/usr/bin:/opt/bin"

#define	LABELIT		"/sbin/labelit"
#define	MKFS		"/sbin/mkfs"
#define CPIOPROC	"/usr/bin/cpio"
#define LSPROC		"/usr/bin/ls"
#define RMCMD		"/usr/bin/rm"
#define MOUNT		"/sbin/mount"
#define UMOUNT		"/sbin/umount"
#define FSTYP		"/sbin/fstyp"
#define DDPROC		"/usr/bin/dd"
#define MAILCMD		"/usr/bin/mail"
#define SHELL		"/sbin/sh"
#define CPCMD		"/usr/bin/cp"

#define MOUNT_FOPT	"-F"

#define MKFS_UFS	"%s -F %s %s %s 1024"
#define MKFS_S5		"%s -F %s %s 2370"

#define SYSADM		"/usr/sadm/sysadm"
#define LOGDIR		"/var/sadm/install/logs"
#define KEYS_FILE       "/etc/config/licensekeys"
#define DTAB_PATH       "/etc/device.tab"
#define VARTMP		"/var/tmp"
#define	ETCFS		"/etc/fs"
#define ETCFSFILE	"labelit"
#define DEFSPOOLDIR	"/var/spool/pkg"    /* hopsadd */

#define	UFS		"ufs"
#define	S5		"s5"
#define DEFAULT_FS	"ufs"

#endif

#endif
