/*
 * MODIFICATION HISTORY
 *
 *	A000	vit@auriga.ru	May 6, 1998
 *		Porting to OpenServer.
 *		Pathnames were changed to defines.
 */

/*LINTLIBRARY*/
#ident	"@(#)progerr.c	15.1"
#ident "$Header: $"

#include "oampkg.h"
#include <stdio.h>
#include <varargs.h>
#include <pwd.h>
#include <limits.h>

#include <pfmt.h>

extern char	*prog;

int	logmode;

/*VARARGS*/
void
progerr(va_alist)
va_dcl
{
	va_list	ap;
	char	*fmt;
	FILE	*logfp = NULL;		/* log file pointer		*/
	char	lname[PATH_MAX];	/* log file name		*/
	char	*pkginst, *getenv();	/* PKGINST in environment	*/


	/*
	 * If error being reported occured during package installation,
	 * and either LOGMODE environment variable was set to "true"
	 * by user or via the -l option on the pkgadd command line
	 * and we know the package instance, do not display error
	 * message on screen.   Instead, place errors in logfile
	 * /var/sadm/install/logs/<pkginst>.log.  Otherwise, the 
	 * error message goes to stderr and logfile. 
	 */

	if(!strcmp(prog, "pkgadd")) {
		pkginst = getenv("PKGINST");
		if (pkginst) {
			(void) sprintf(lname, "%s/%s.log", LOGDIR, pkginst); /* A000 */
			if((logfp = fopen(lname, "a")) == NULL)
				pfmt(stderr, MM_WARNING, "uxpkgtools:687:could not open log file <%s>\n", lname);
		}
	}
		
	va_start(ap);

	fmt = va_arg(ap, char *);
	if(!logmode) {
		(void) vpfmt(stderr, MM_ERROR, fmt, ap);
		(void) fprintf(stderr, "\n");
	}
	if(logfp) {
		(void) vpfmt(logfp, MM_ERROR, fmt, ap);
		(void) fprintf(logfp, "\n");
		(void) fclose(logfp);
	}

	va_end(ap);

}

/*VARARGS*/
void
nlprogerr(va_alist)
va_dcl
{
	va_list	ap;
	char	*fmt;

	va_start(ap);

	fmt = va_arg(ap, char *);
	(void) vpfmt(stderr, MM_ERROR, fmt, ap);
	(void) fprintf(stderr, "\n");

	va_end(ap);

}
