#!/bin/ksh
# @(#) pkgdsls - list files in package datastream

usage()
{
    [ $# -gt 0 ] && echo $*
    echo "pkgdsls - list sfiles in pkg datastream file"
    echo "usage: pkgdsls [-v] file [ file...]"
    exit 1
}


dsls ()
{
    File=$1
    let i=0
    pkgls=
    
    # read header
    dd if=$File count=1 2>/dev/null | {
        read c pkg type
#        echo $c $pkg $type
        [ $c = '#' -a $pkg = 'PaCkAgE' -a $type = 'DaTaStReAm' ] || 
            usage 'File must be Datastream pkg'
    
        while :; do
            read pkg volume junk
            pkgls="$pkgls $pkg"
            [ "$pkg" = "#" ] && break
            let i=i+1
        done
    }
    
    set $pkgls
    ((i=i+1))
    let j=0
    # dump cpio part contents
    dd if=$File skip=1 ibs=512 2>/dev/null | while ((j != i))
    do
        if (( j == 0 )) ; then  # ignore first - some sort of pkg* info files
            cpio -icvtumD -C 512 >/dev/null 2>&1
        else
            echo "--- $1 ---" ; shift
            cpio -ictumD -C 512 $verbose 2>/dev/null
        fi
        ((j=j+1))
    done

}

while getopts v c
do
    case $c in
    v) verbose='-v' ;;
    \?) usage  ;;
    esac
done
shift `expr $OPTIND - 1`

[ $# = 0 ] && usage "No Filenames"

for i in $*; do
    dsls  $i
done
