/*		copyright	"%c%" 	*/

#ident	"@(#)predepend.c	15.1"
#ident  "$Header: predepend.c 1.2 91/06/27 $"

#include "oampkg.h"
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <string.h>
#include <limits.h>
#include <pkglocs.h>

extern char	*pkgname;
extern char	pkgloc[];
extern int	warnflag;

extern void	progerr();
extern int	unlink(),
		symlink();

#define ERR_RMLINK	":421:unable to remove options file <%s>"
#define ERR_SYMLINK	":422:unable to create symbolic link from <%s> to <%s>"
#define ERR_PREDEPEND	":423:unable to create predepend file <%s>"

void
predepend(oldpkg)
char	*oldpkg;
{
	FILE	*fp;
	char	path[PATH_MAX];
	char	spath[PATH_MAX];
	struct stat statbuf;

	oldpkg = strtok(oldpkg, " \t\n");
	if(oldpkg == NULL)
		return;

	(void) sprintf(path, "%s/predepend", pkgloc);
	if((fp = fopen(path, "w")) == NULL) {
		progerr(ERR_PREDEPEND, path);
		warnflag++;
		return;
	}
	(void) fprintf(fp, "%s\n", pkgname);
	(void) fclose(fp);

	do {
		(void) sprintf(spath, "%s/%s.name", PKGOLD, oldpkg);
		if(lstat(spath, &statbuf) == 0) {
			/* options file already exists */
			if(statbuf.st_mode & S_IFLNK) {
				/* remove current link */
				if(unlink(spath)) {
					progerr(ERR_RMLINK, spath);
					warnflag++;
				}
			}
		}
		if(symlink(path, spath)) {
			progerr(ERR_SYMLINK, path, spath);
			warnflag++;
		}
	} while(oldpkg = strtok(NULL, " \t\n"));
}
